from System.Collections.Generic import List
from System import Byte, Int32
#
# Set this to the exact name of your pick script .. capital matters
# and it has to be in your list of scripts on UI
#
#
# First keep track of position in book 
#
RuneBook = 0x4017B80D
if Player.Name == "Greed":
    RuneBook = 0x4225978D
#
#
# Next keep track of position in book. At end of a book we'll set next book 
#
RuneOrder = [ 7, 13, 19, 25, 31, 37, 43, 49, 55, 61] #, 59, 65, 71, 77, 83, 95 ] 
#
# A function I'll need later to check if runbook entry is Empty
#
def RuneBookFirstNameIndex():    
    gumpList = Gumps.LastGumpGetLineList()
    textParts = ["Charges:", "Max Charges:", "Rename book", "Drop rune", 
                 "Set default", "Recall", "Gate Travel", "Sacred Journey" ]
    index = 0
    #Misc.SendMessage("text: {}".format(gumpList[index]), 7)
    while gumpList[index].strip() in textParts:
        #Misc.SendMessage("text: {}".format(gumpList[index]), 7)
        index = index + 1
        # now index should be at the charges numbers so skip 1 more
    index = index + 2
    #Misc.SendMessage("Starts at: {}".format(index))
    return index
    
def kill(name):
    while True:
        filter = Mobiles.Filter()
        filter.Name = name
        filter.RangeMax = 20
        mobs = Mobiles.ApplyFilter(filter)
        if len(mobs) > 0:
            #Player.SetWarMode(True)
            mob = mobs[0]       
            if Player.ManaMax > 162:
                if Player.DistanceTo(mob) > 8:
                    route = PathFinding.Route()
                    route.X = mob.Position.X+5
                    route.Y = mob.Position.Y-5
                    route.UseResync = False
                    route.MaxRetry = 2
                    PathFinding.Go(route)
                Spells.CastMagery("Energy Bolt", mob)
                Misc.Pause(2500)                                     
            else:
                if Player.DistanceTo(mob) > 2:
                    route = PathFinding.Route()
                    route.X = mob.Position.X
                    route.Y = mob.Position.Y
                    route.UseResync = False
                    route.MaxRetry = 2
                    PathFinding.Go(route)                
                Player.Attack(mob)    
        else:
            break
        Misc.Pause(1000)    
    Player.SetWarMode(False)        
                
def get_quest():
    Misc.SendMessage("Should get Quest")
    questGiver = Mobiles.FindBySerial(0x00000D05)
    if Player.DistanceTo(questGiver) > 2:
        Player.PathFindTo(questGiver.Position.X, questGiver.Position.Y, questGiver.Position.Z)
        while Player.DistanceTo(questGiver) > 2:
            Misc.Pause(1000)
    noQuest = True
    while noQuest:
        Journal.Clear()        
        Misc.WaitForContext(questGiver, 2000)
        Misc.ContextReply(questGiver, "Talk")
        Misc.Pause(1000)
        if Journal.Search("check back"):
            noQuest = True
            Player.UseSkill("Hiding")
            Misc.Pause(5*60000)
        else:
            noQuest = False                
    Gumps.WaitForGump(0, 1000)
    if Gumps.LastGumpTextExist("Bah your worthless"):
        Gumps.SendAction(0, 0)
    elif Gumps.LastGumpTextExist("Quest Offer"):
        Gumps.SendAction(0, 4)    

def get_yeast():
    Misc.SendMessage("Kill the Farmer")
    kill("Hayden Failstor")
    
def attack_blood_lich():
    Misc.SendMessage("Kill BloodLich")
    kill("a blood lich")

def kill_Yoshimitsu():
    kill("Yoshimitsu")
    
def kill_Bacchus():    
    kill("Bacchus")
    
    
def first_meeting_vincent():
    Misc.SendMessage("Talk to Vincent first time")
    questGiver = Mobiles.FindBySerial(0x00000D0C)
    if Player.DistanceTo(questGiver) > 2:
        Player.PathFindTo(questGiver.Position.X, questGiver.Position.Y, questGiver.Position.Z)
        while Player.DistanceTo(questGiver) > 2:
            Misc.Pause(1000)        
    Misc.WaitForContext(questGiver, 2000)
    Misc.ContextReply(questGiver, "Talk")
    Misc.Pause(3000)
    
def meet_linda():
    Misc.SendMessage("Meet Linda")
    questGiver = Mobiles.FindBySerial(0x00000D11)
    if Player.DistanceTo(questGiver) > 2:
        Player.PathFindTo(questGiver.Position.X, questGiver.Position.Y, questGiver.Position.Z)
        while Player.DistanceTo(questGiver) > 2:
            Misc.Pause(1000)
    Misc.WaitForContext(questGiver, 2000)
    Misc.ContextReply(questGiver, "Talk")            
    Misc.Pause(2000)        
    
    
def second_meeting_vincent():
    Misc.SendMessage("Talk to Vincent second time")
    questGiver = Mobiles.FindBySerial(0x00000D0C)
    if Player.DistanceTo(questGiver) > 2:
        Player.PathFindTo(questGiver.Position.X, questGiver.Position.Y, questGiver.Position.Z)
        while Player.DistanceTo(questGiver) > 2:
            Misc.Pause(1000)
    Misc.WaitForContext(questGiver, 3000)
    Misc.ContextReply(questGiver, "Talk")
    Misc.Pause(2000)
    Items.WaitForContents(Player.Backpack, 3000)
    questItem = Items.FindByID (0x09A1, -1, Player.Backpack.Serial)
    if questItem != None:
        Misc.WaitForContext(Player.Serial, 2000)
        Misc.ContextReply(Player.Serial, "Toggle Quest Item")
        Target.WaitForTarget(3000)
        Misc.Pause(1000)
        Target.TargetExecute(questItem.Serial)
        Target.Cancel()
        Misc.SendToClient("{ESC}\n")

def finish_quest():
    Misc.SendMessage("Should get Quest")
    questGiver = Mobiles.FindBySerial(0x00000D05)
    if Player.DistanceTo(questGiver) > 2:
        Player.PathFindTo(questGiver.Position.X, questGiver.Position.Y, questGiver.Position.Z)
        while Player.DistanceTo(questGiver) > 2:
            Misc.Pause(1000)
    Misc.WaitForContext(questGiver, 3000)
    Misc.ContextReply(questGiver, "Talk")
    Gumps.WaitForGump(0, 5000)
    Gumps.SendAction(0, 8)
    Gumps.WaitForGump(0, 5000)
    Gumps.SendAction(0, 5)    
#        
#
# Now finally everything is set. 
#
#
# RuneBookIndex is set to the current book to use
# RuneIndex is set to which rune in that book to use
for RuneIndex in range(len(RuneOrder)):
    Gumps.ResetGump()
    bookOpen = False
    while not bookOpen:
        Items.UseItem(RuneBook)
        Gumps.WaitForGump(Gumps.CurrentGump(), 1000)
        if Gumps.HasGump():
            bookOpen = True
    #        
    bookSlotName = Gumps.LastGumpGetLine(RuneBookFirstNameIndex()+RuneIndex)
    Misc.SendMessage(bookSlotName.strip().lower()) 
    if bookSlotName.strip().lower() != "empty":
        Gumps.SendAction(Gumps.CurrentGump(), RuneOrder[RuneIndex])
    Misc.Pause(5000)
    # recall then action
    Action = { 0 : get_quest, 1: get_yeast, 2: kill_Yoshimitsu, 3 : attack_blood_lich, 4 : kill_Bacchus, 5 : first_meeting_vincent, 6: meet_linda, 7: second_meeting_vincent, 8 : finish_quest }
    if RuneIndex in Action: 
        Action[RuneIndex]()

Misc.Pause(30*60000)
    
    

